/**
 * debug.h -- debugging output for TSMforth.  Functions very
 * similarly to printf, being based on it.
 *
 * There are two levels of debugging output, absolute and disableable.
 *   tsm_debug("something %d\n",4); will always print, while
 *   DEBUG_PRINT(("something %d\n",4)); will only print when DEBUG
 * is defined -- otherwise it is silently stripped out.  Note the
 * double brackets.  They are necessary to disable it at compile-time.
 */
#ifndef __DEBUG_H__
#define __DEBUG_H__

#ifdef __cplusplus
extern "C" {
#endif

extern void tsm_debug(const char *cmdstr,...);

#ifdef __cplusplus
}
#endif

#ifdef DEBUG
#define DEBUG_PRINT(x) tsm_debug x
#else
#define DEBUG_PRINT(x)
#endif

#endif/*__DEBUG_H__*/
