#include <stdio.h>
#include <stdlib.h>
#include "tsmforth.h"

tsm_ctx *ctx_create(tsm_code *code, const char *entry)
{
  tsm_ctx *ctx=NULL;

  if((code==NULL)||(entry==NULL)) goto CTX_ERROR;
  ctx=(tsm_ctx *)malloc(sizeof(tsm_ctx));
  if(ctx==NULL) goto CTX_ERROR;

  ctx->stack=tsm_stack_create(1024);
  if(ctx->stack==NULL) goto CTX_ERROR;
  ctx->locals=hash_create(LOCAL_MAX);
  if(ctx->locals == NULL) goto CTX_ERROR;

  ctx->code=code;
  ctx->depth=0;
  ctx->freecode=0;

  ctx->ip[0]=code_getentry(code,entry);
  if(ctx->ip[0]==0)
    goto CTX_ERROR;

  return(ctx);

CTX_ERROR:
  if(ctx!=NULL) ctx_free(ctx);
  return(NULL);
}

void ctx_free(tsm_ctx *ctx)
{
  if(ctx!=NULL)
  {
    if(ctx->freecode && ctx->code) code_free(ctx->code);
    if(ctx->stack!=NULL)           tsm_stack_free(ctx->stack);
    if(ctx->locals!=NULL)          hash_free(ctx->locals);
    free(ctx);
  }  
}

