#include <stdio.h>
#include <string.h>
#include "tsmtypes.h"
#include "tsmforth.h"

static long fstrlen(const void *d) { return(strlen(d)+1);              }
static void print_instr(const void *i) { printf("[%d]",*(const int *)i); }

static int instr_to_str(char *buf, const void *d)
{
  tsm_inst_e i=*(tsm_inst_e *)d;
  if((i<0)||(i>=TSM_LAST)) return(-1);
  sprintf(buf,"[%s]",tsm_instr[i].token);
  return(0);
}

const var_handler vhandlers[]={
  /* DO NOT MESS WITH THESE THREE TYPES!  They are builtins */
  { sizeof(int)      , NULL   , NULL       , NULL         },
  { 0                , fstrlen, NULL       , NULL         },
  { sizeof(tsm_inst_e), NULL   , print_instr, instr_to_str },
  /* End of builtins */

  /* Add your own type handlers here */

  /* This line means 'end of list', do not modify */
  { -1               , NULL   , NULL       , NULL         }
};

const int type_max=sizeof(vhandlers)/sizeof(var_handler);

long tsm_var_size(const tsm_data_e type, const void *ptr)
{
  if((type >= type_max)||(type<0)) return(-1);

  if(vhandlers[type].fn) return(vhandlers[type].fn(ptr));
  return(vhandlers[type].fixed);
}
